package info;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

//import org.apache.hadoop.conf.Configruation;
//import org.apache.hadoop.fs.ContentSummary;
//import org.apache.hadoop.fs.FileSystem;
//import org.apache.hadoop.fs.Path;
//import org.apache.hadoop.security.UserGroupInformation;

public class UpdateCountCDHnCDP {
	
	public void start() throws Exception {
		
		String[] cdh_result = null;
		String[] cdp_result = null;
		
		long cdhLine = 0;
		long cdpLine = 0;
		int i=0;
		
		File cdh_file = new File("script/cdp/count_cdh_result");
		File cdp_file = new File("script/cdp/count_cdp_result");

		
		if(cdh_file.exists()) {
			
			BufferedReader inFile = new BufferedReader(new FileReader(cdh_file));
			cdhLine = inFile.lines().count();
			inFile.close();
			
			inFile = new BufferedReader(new FileReader(cdh_file));
			cdh_result = new String[(int) cdhLine];
			
			String sLine = null;
			i=0;
			
			while((sLine = inFile.readLine()) != null) {
				
				sLine = sLine.replace(".", ",").replace(" ", ",").replaceAll("\\t", ",").replaceAll(",+", ",");
				cdh_result[i] = sLine;
				System.out.println("cdh_result["+i+"]="+cdh_result[i]);
				i++;
			}
			inFile.close();
		}
		
		if(cdp_file.exists()) {
			
			BufferedReader inFile = new BufferedReader(new FileReader(cdp_file));
			cdpLine = inFile.lines().count();
			inFile.close();
			
			inFile = new BufferedReader(new FileReader(cdp_file));
			cdp_result = new String[(int) cdpLine];
			
			String sLine = null;
			i=0;
			
			while((sLine = inFile.readLine()) != null) {
				
				sLine = sLine.replace(".", ",").replace(" ", ",").replaceAll("\\t", ",").replaceAll(",+", ",");
				cdp_result[i] = sLine;
				//System.out.println("cdp_result["+i+"]="+cdp_result[i]);
				i++;
			}
			inFile.close();
		}

		
		Connection cdp_impala_conn;
		cdp_impala_conn = DriverManager.getConnection(
				//"jdbc:impala://192.168.57.171:21050/default;UseNativeQuery=1","hive","Hadoop1!");
				//"jdbc:impala://192.168.57.171:21050/default;AuthMech=3;UseNativeQuery=1","hadoop","123456q!");
				"jdbc:impala://192.168.57.171:21050/default;AuthMech=3;UseNativeQuery=1;OptimizedInsert=0;PreparedMetaLimitZero=0;CastStringParamsForInert=0;NonSSPs=CastStringParamsForInert","hadoop","123456q!");
			
		
		Statement cdp_stmt = cdp_impala_conn.createStatement();
		
		try {
			
			for(int j=0; j<cdhLine; j++) {
				
				String[] tables = cdh_result[j].split(",");
				cdp_stmt.execute("update default.compare_cdh_cdp set cdh_count = " +"'"+tables[2]+"'"+" where db_nm = "+"'"+tables[0]+"'"+" and tbl_nm = "+"'"+tables[1]+"'");
			}
			System.out.println("update complete cdh count");
			
			for(int j=0; j<cdpLine; j++) {
				
				String[] tables = cdp_result[j].split(",");
				cdp_stmt.execute("update default.compare_cdh_cdp set cdp_count = " +"'"+tables[2]+"'"+" where db_nm = "+"'"+tables[0]+"'"+" and tbl_nm = "+"'"+tables[1]+"'");
			}
			System.out.println("update complete cdp count");
			
			//cdp_stmt.execute("update default.compare_cdh_cdp set compare_count = 'X'");
			cdp_stmt.execute("update default.compare_cdh_cdp set compare_count = '' where cdh_count is null and cdp_count is null");
			cdp_stmt.execute("update default.compare_cdh_cdp set compare_count = 'X' where cdh_count <> cdp_count");
			cdp_stmt.execute("update default.compare_cdh_cdp set compare_count = 'O' where cdh_count = cdp_count");
			
			System.out.println("update complete compare count");
		}
		finally {
			cdp_stmt.close();
			cdp_impala_conn.close();
		}
	}

		
		
		
	public static void main(String[] args) throws Exception {
		
		long s = System.currentTimeMillis();
		
		UpdateCountCDHnCDP test = new UpdateCountCDHnCDP();
		test.start();
		
		System.out.printf("%,.3f sec%n", (System.currentTimeMillis() - s) / 1000f);
	}
}