package info;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.ContentSummary;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.security.UserGroupInformation;



public class CompareHistoryCDHPRDnCDP {
	public void start() throws Exception {
		System.setProperty("HADOOP_USER_NAME", "hdfs");
		
		Connection conn;
		String sys_nm;
		
		List<String> cdh_tables = new ArrayList<>();
		List<String> cdp_tables = new ArrayList<>();

		sys_nm = "cdh_prd";
		conn = DriverManager.getConnection("jdbc:mysql://ip:port/metastore?userSSL=false","id","pw");
		List<String> tables_cdh = getTableInfo(sys_nm, conn);
		getHdfsInfo(sys_nm, tables_cdh);
		
		cdh_tables.addAll(tables_cdh);
		System.out.println("get cdh_tables");
		
		 
		sys_nm = "cdp";
		conn = DriverManager.getConnection("jdbc:mysql://ip:port/metastore?useSSL=false","id","pw");
		List<String> tables_cdp = getTableInfo(sys_nm, conn);
		getHdfsInfo(sys_nm, tables_cdp);
		
		cdp_tables.addAll(tables_cdp);
		System.out.println("get cdp_tables");
		
		
		conn = DriverManager.getConnection(
				"jdbc:impala://ip:port/default;AuthMech=3;UseNativeQuery=1;OptimizedInsert=0;PreparedMetaLimitZero=0;CastStringParamsForInert=0;NonSSPs=CastStringParamsForInert","id","pw");
		
		//Statement stmt = conn.createStatement();
		//stmt.execute("delete from default.compare_cdh_cdp");
		
		PreparedStatement pstmt = conn.prepareStatement(
				"upsert into default.compare_history_cdh_cdp(sys_id,db_nm,tbl_nm,create_time,compare_db_tbl,db_tbl,compare_owner,cdh_owner,cdp_owner,compare_type,cdh_type,cdp_type,compare_comments,cdh_comments,cdp_comments,compare_column_s,cdh_column_s,cdp_column_s,compare_part_s,cdh_part_s,cdp_part_s,compare_loc,cdh_loc,cdp_loc,compare_len,cdh_len,cdp_len,reg_dt) " +
		        "values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
		
		
		/*
		 * 1.sys,2.db,3.tbl,4.create_time,5.compare_db_tbl,6.db_tbl,7.compare_owner,8.cdh_owner,9.cdp_owner
		 * 10.compare_type,11.cdh_type,12.cdp_type,13.compare_comments,14.cdh_comments,15.cdp_comments
		 * 16.compare_cloumn_s,17.cdh_column_s,18.cdp_column_s,19.compare_part_s,20.cdh_part_s,21.cdp_part_s
		 * 22.compare_loc,23.cdh_loc,24.cdp_loc,25.compare_len,26.cdh_len,27.cdp_len
		 */

		StringBuilder create_table_cdp_list = new StringBuilder();
		StringBuilder distcp_cdp_list = new StringBuilder();
		StringBuilder msck_repair_cdp_list = new StringBuilder();
		StringBuilder analyze_cdp_list = new StringBuilder();
		StringBuilder refresh_impala_cdp_list = new StringBuilder();
		StringBuilder count_cdp_list = new StringBuilder();
		StringBuilder count_all_cdp_list = new StringBuilder();
		StringBuilder refresh_all_impala_cdp_list = new StringBuilder();
		StringBuilder msck_repair_all_cdp_list = new StringBuilder();
		
		int rows = 0;
		try {
			for (String cdh_line : cdh_tables) {
				rows++;
				
				String db_tbl_name="nothing";
				String cdp_owner="";
				String cdp_tbl_type="";
				String cdp_comments="";
				String cdp_cols="";
				String cdp_parts="";
				String cdp_loc="";
				String cdp_length="";
				
				String[] cdh_arr = cdh_line.split("\t", 16);
				String cdh_tbl_name = cdh_arr[1] + cdh_arr[2];
				
				
				// skip table or view
				if(cdh_tbl_name.compareTo("dm_intvw_hd_etl_log")==0) continue;
				if(cdh_tbl_name.compareTo("if_wextemp_asset_view")==0) continue;
				if(cdh_tbl_name.compareTo("if_wexuidx_index_inf_inner_view_2")==0) continue;
				if(cdh_tbl_name.compareTo("if_wexuidx_portfolio_view")==0) continue;
				if(cdh_tbl_name.compareTo("if_wexwex_fctr_view")==0) continue;
				if(cdh_tbl_name.compareTo("if_wexwex_fevt_view_old")==0) continue;
				if(cdh_tbl_name.compareTo("if_wexwex_omi_mst_view")==0) continue;
				if(cdh_tbl_name.compareTo("if_wexwex_sntmnt_mst_view")==0) continue;
				
				// reg date
				SimpleDateFormat sDate = new SimpleDateFormat("yyyyMMddHH");
				String reg_dt = sDate.format(new Date());

				
				count_all_cdp_list.append("select " + '"' +cdh_arr[1] + "." + cdh_arr[2] + '"' +", count(1) from " + cdh_arr[1] + "." + cdh_arr[2]).append(";\n");
				refresh_all_impala_cdp_list.append("refresh " + cdh_arr[1] + "." + cdh_arr[2]).append(";\n");
				
						
				if(Integer.parseInt(cdh_arr[10]) > 0) {
					msck_repair_cdp_list.append("msck repair table " + cdh_arr[1] + "." + cdh_arr[2]).append(" sync partitions;\n");
				}
				
				for(String cdp_line : cdp_tables) {
					String[] cdp_arr = cdp_line.split("\t", 16);
					
					if(cdh_tbl_name.compareTo(cdp_arr[1]+cdp_arr[2])==0) {
						db_tbl_name = cdh_arr[1] + "." + cdh_arr[2];
						System.out.println(db_tbl_name);
						
						cdp_owner = cdp_arr[6];
						cdp_tbl_type = cdp_arr[3];
						cdp_comments = cdp_arr[4];
						cdp_cols = cdp_arr[7];
						cdp_parts = cdp_arr[10];
						cdp_loc = cdp_arr[8];
						cdp_length = cdp_arr[15];
					}
					else continue;
				}
				
				/* arr[]
				 * arr[0] : sys_nm, arr[1] : db_name, arr[2] : tbl_name, arr[3] : tbl_type, arr[4] : comments, arr[5] : create_time,
				 * arr[6] : owner, arr[7] : cols, arr[8] : loc_as, arr[9] : loc_to, arr[10] : parts, arr[11] : part_cols,
				 * arr[12] : part_cnt, arr[13] : dirs, arr[14] : files, arr[15] : length
				 */
				
				/*
				 * 1.sys,2.db,3.tbl,4.create_time,5.compare_db_tbl,6.db_tbl,7.compare_owner,8.cdh_owner,9.cdp_owner
				 * 10.compare_type,11.cdh_type,12.cdp_type,13.compare_comments,14.cdh_comments,15.cdp_comments
				 * 16.compare_cloumn_s,17.cdh_column_s,18.cdp_column_s,19.compare_part_s,20.cdh_part_s,21.cdp_part_s
				 * 22.compare_loc,23.cdh_loc,24.cdp_loc,25.compare_len,26.cdh_len,27.cdp_len
				 */
				
				pstmt.setString(1, cdh_arr[0]);
				pstmt.setString(2, cdh_arr[1]);
				pstmt.setString(3, cdh_arr[2]);
				pstmt.setString(4, cdh_arr[5]);
				
				if(db_tbl_name.compareTo("nothing")==0) {
					pstmt.setString(5, "X");
					db_tbl_name ="";
					
					create_table_cdp_list.append(cdh_arr[1] + "," + cdh_arr[2]).append("\n");
					
				} else pstmt.setString(5, "O");
				
				pstmt.setString(6, db_tbl_name);
				
				if(cdh_arr[6].compareTo(cdp_owner)==0) {
					pstmt.setString(7,"O");
					
				} else pstmt.setString(7, "X");
				
				pstmt.setString(8, cdh_arr[6]);
				pstmt.setString(9, cdp_owner);
				
				if(cdh_arr[3].compareTo(cdp_tbl_type)==0) {
					pstmt.setString(10, "O");
					
				} else pstmt.setString(10, "X");
				
				pstmt.setString(11, cdh_arr[3]);
				pstmt.setString(12, cdp_tbl_type);
				
				if(cdh_arr[4].compareTo(cdp_comments)==0) {
					pstmt.setString(13, "O");
					
				} else pstmt.setString(13, "X");
				
				pstmt.setString(14, cdh_arr[4]);
				pstmt.setString(15, cdp_comments);
				
				if(cdh_arr[7].compareTo(cdp_cols)==0) {
					pstmt.setString(16, "O");
					
				} else pstmt.setString(16, "X");
				
				pstmt.setString(17, cdh_arr[7]);
				pstmt.setString(18, cdp_cols);
				
				if(cdh_arr[10].compareTo(cdp_parts)==0) {
					pstmt.setString(19, "O");
					
				} else pstmt.setString(19, "X");
				
				pstmt.setString(20, cdh_arr[10]);
				pstmt.setString(21, cdp_parts);
				
				if(cdh_arr[8].replace("hdfs://nameservice1","").compareTo(cdp_loc.replace("hdfs://ai-cdpmn-01p.shai.ad:8020", ""))==0) {
					pstmt.setString(22, "O");
					
				} else pstmt.setString(22, "X");
				
				pstmt.setString(23, cdh_arr[8]);
				pstmt.setString(24, cdp_loc);
				
				if(cdh_arr[15].isEmpty()) {
					cdh_arr[15] = "0";
				}
				if(cdh_arr[15].compareTo(cdp_length)==0) {
					pstmt.setString(25, "O");
					
				} else {
					pstmt.setString(25, "X");
					
					if(db_tbl_name.length() > 0 && !(cdh_arr[8].compareTo("null")==0 || cdh_arr[8].compareTo("null")==0)) {
						//System.out.println("cdh_arr[8]="+cdh_arr[8]+" / cdp_loc="+cdp_loc);
						//if(cdh_arr[8].compareTo("null")==0) { System.out.println("cdh_arr[8] is null");}
						//if(cdp_loc.compareTo("null")==0) { System.out.println("cdp_loc is null");}
						
						distcp_cdp_list.append("time hadoop distcp -D mapreduce.job.name="+ cdh_arr[1] +"."+ cdh_arr[2]+" -m 20 -bandwidth 50 -direct -filters ~/distcpfilter -skipcrccheck -p -i -delete -update ");
						distcp_cdp_list.append(cdh_arr[8].replace("nameservice1","shainm1p.shai.ad:8020"));
						distcp_cdp_list.append(" " + cdp_loc).append("\n");
						
						analyze_cdp_list.append("analyze table "+ cdh_arr[1] + "." + cdh_arr[2] +" compute statistics for columns").append(";\n");
						refresh_impala_cdp_list.append("refresh "+ cdh_arr[1] +"." + cdh_arr[2]).append(";\n");
						count_cdp_list.append("select "+ '"' + cdh_arr[1] + "." + cdh_arr[2]+ '"'+" , count(1) from " + cdh_arr[1] + "." + cdh_arr[2]).append(";\n");
						
						/*
						 * if(cdh_arr[10].compareTo("1")==0)
						 *   msck_repair_cdp_list.append("msck repair table " + cdh_arr[1] + "." + cdh_arr[2]).append(" sync partitions;\n");
						 */
						msck_repair_all_cdp_list.append("msck repair table " + cdh_arr[1]+"."+cdh_arr[2]).append(" sync partitions;\n");
					}
				}
				
				if(cdh_arr[3].compareTo("VIRTUAL_VIEW")==0) {
					pstmt.setString(25, "O");
					pstmt.setString(26, "0");
					pstmt.setString(27, "0");
				}
				else {
					pstmt.setString(26, cdh_arr[15]);
					pstmt.setString(27, cdp_length);
				}
				pstmt.setString(28, reg_dt);
				
				pstmt.addBatch();
				
				if((rows % 100) == 0) {
					pstmt.executeBatch();
				}
			}
			if(rows % 100 != 0 ) {
				pstmt.executeBatch();
			}
		} finally {
			//stmt.close();
			pstmt.close();
			conn.close();
		}
		
		System.out.printf("%, d rows%n", rows);
		
		
		System.out.println("create file : create_table_list_cdp_prd");
		File wfile01 = new File("script/cdh_prd/create_table_list_cdp_prd");
		
		try {
			wfile01.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile01, true), "utf-8"));
			writer.write(create_table_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
		System.out.println("create file : distcp_cdp_list");
		File wfile02 = new File("script/cdp/distcp_cdp_list");
		try {
			wfile02.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile02, true), "utf-8"));
			writer.write(distcp_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
		System.out.println("create file : msck_repair_cdp_list");
		File wfile03 = new File("script/cdp/msck_repair_cdp_list");
		try {
			wfile03.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile03, true), "utf-8"));
			writer.write(msck_repair_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("create file : analyze_cdp_list");
		File wfile04 = new File("script/cdp/analyze_cdp_list");
		try {
			wfile04.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile04, true), "utf-8"));
			writer.write(analyze_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("create file : refresh_impala_cdp_list");
		File wfile05 = new File("script/cdp/refresh_impala_cdp_list");
		try {
			wfile05.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile05, true), "utf-8"));
			writer.write(refresh_impala_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("create file : count_cdp_list");
		File wfile06 = new File("script/cdp/count_cdp_list");
		try {
			wfile06.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile06, true), "utf-8"));
			writer.write(count_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("create file : count_all_cdp_list");
		File wfile07 = new File("script/cdp/count_all_cdp_list");
		try {
			wfile07.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile07, true), "utf-8"));
			writer.write(count_all_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("create file : refresh_all_impala_cdp_list");
		File wfile08 = new File("script/cdp/refresh_all_impala_cdp_list");
		try {
			wfile08.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile08, true), "utf-8"));
			writer.write(refresh_all_impala_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("create file : msck_repair_all_cdp_list");
		File wfile09 = new File("script/cdp/msck_repair_all_cdp_list");
		try {
			wfile09.delete();
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(wfile09, true), "utf-8"));
			writer.write(msck_repair_all_cdp_list.toString());
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


		
	private Map<String, String> loadComments() throws Exception{
		Map<String, String> map = new HashMap<>();
		
		String line;
		BufferedReader br = new BufferedReader(
				new InputStreamReader(getClass().getResourceAsStream("comments"), "UTF-8"));
		
		while ((line = br.readLine()) != null) {
			String[] arr = line.split("\t", 3);
			map.put(arr[0] + "."+arr[1], arr[2]);
		}
		return map;
	}
		
	
	private void getHdfsInfo(String sys_nm, List<String> tables) throws Exception {
		Configuration conf = new Configuration();
		if(sys_nm.equals("cdh_prd")) {
			conf.addResource(new Path("conf/cdh_prd/core-site.xml"));
			conf.addResource(new Path("conf/cdh_prd/hdfs-site.xml"));
			conf.setBoolean("fs.hdfs.impl.disable.cache",true);
		}
		else if(sys_nm.equals("cdp")) {
			conf.addResource(new Path("conf/cdp_prd/core-site.xml"));
			conf.addResource(new Path("conf/cdp_prd/hdfs-site.xml"));
			conf.setBoolean("fs.hdfs.impl.disable.cache",true);
		}
		else {
			throw new RuntimeException("sys_nm is (cdh_prd, cdp)");
		}
		
		FileSystem hdfs = FileSystem.get(conf);
		try {
			for (int i=0; i<tables.size(); i++) {
				String line = tables.get(i);
				String[] arr = line.split("\t", 13);
				String loc_as = arr[8];
			
				try {
					ContentSummary summary = hdfs.getContentSummary(new Path(loc_as));
					
					long dirs = summary.getDirectoryCount();
					long files = summary.getFileCount();
					long length = summary.getLength() - summary.getSnapshotLength();
					
					line += String.format("\t%s\t%s\t%s", dirs, files, length);		
				}
				catch (FileNotFoundException | IllegalArgumentException e) {
					//line += "\t\t\t";
					line += String.format("\t%s\t%s\t%s", "", "", "");
				}
				finally {
					System.out.println(i+1 + " "+ line);
					tables.set(i, line);
				}
			}
		} finally {
			hdfs.close();
		}
	}
	
	private List<String> getTableInfo(String sys_nm, Connection conn) throws Exception {
		
		
		Map<String, String> map;
		if(sys_nm.equals("cdh_prd")) {
			map = null;
		}
		else if (sys_nm.equals("cdp")) {
			map = null;
		}
		else {
			throw new RuntimeException("sys_nm is (cdh_prd, cdp)");
		}
		
		List<String> tables = new ArrayList<>();
		try {
			Statement stmt = conn.createStatement();
			
			ResultSet rs = stmt.executeQuery(
					"select a.NAME, b.TBL_NAME, b.TBL_TYPE,\n" +
							"(select PARAM_VALUE from metastore.TABLE_PARAMS where TBL_ID = b.TBL_ID and PARAM_KEY='comment') as COMMENTS, \n" +
							"from_unixtime(b.CREATE_TIME) as CREATE_TIME, b.OWNER,\n" +
							"(select count(1) from metastore.COLUMNS_V2 where CD_ID = c.CD_ID) as COLUMNS,\n" +
							"c.LOCATION as LOC_AS,\n" +
							"concat('/data', '/', a.NAME, '/', b.TBL_NAME) as LOC_TO,\n" +
							"(select count(1) from metastore.PARTITION_KEYS where TBL_ID = b.TBL_ID) as PARTS,\n" +
							"(select group_concat(PKEY_NAME) from metastore.PARTITION_KEYS where TBL_ID = b.TBL_ID) as PART_COLS,\n" +
							"(select count(1) from metastore.PARTITIONS where TBL_ID = b.TBL_ID) as PART_CNT\n" +
							"from metastore.DBS a\n"+
							"join metastore.TBLS b\n"+
							" on b.DB_ID = a.DB_ID\n" +
							"join metastore.SDS c\n" +
							" on c.SD_ID = b.SD_ID\n" +
							"where a.NAME not in ('sys', 'information_schema')\n" +
							" and b.TBL_NAME not in ('compare_cdh_cdp','tbl_info_cdh_dev','tbl_info_cdh_prd','remove_list_cdp','compare_history_cdh_cdp')\n" +
							//"where a.NAME in ('analysis','default')\n" +
							//"where a.NAME in ('risk')\n" +
							"order by 1, 2\n"
					);
			while (rs.next()) {
				String db_name = rs.getString("NAME");
				String tbl_name = rs.getString("TBL_NAME");
				String tbl_type = rs.getString("TBL_TYPE");
				String comments = rs.getString("COMMENTS");
				if(comments == null) comments ="";
				
				String create_time = rs.getString("CREATE_TIME");
				create_time = create_time.replaceAll("\\.0$", "");
				
				String owner = rs.getString("OWNER");
				String cols = rs.getString("COLUMNS");
				String loc_as = rs.getString("LOC_AS");
				String loc_to = rs.getString("LOC_TO");
				String parts = rs.getString("PARTS");
				String part_cols = rs.getString("PART_COLS");
				if(part_cols == null) part_cols ="";
				
				String part_cnt = rs.getString("PART_CNT");
				
				if(comments.isEmpty() || comments.contains("?")) {
					if(map != null) {
						String cmt = map.get(db_name +"."+ tbl_name);
						if(cmt != null) {
							comments = cmt;
						}
					}
				}
				
				String line = String.format("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s",
						sys_nm,db_name,tbl_name,tbl_type,comments,create_time,owner,cols,loc_as,loc_to,parts,part_cols,part_cnt);
				
				tables.add(line);
				
			}
			rs.close();
			stmt.close();
			
		} finally {
			conn.close();
		}
		
		System.out.println("getTableInfo : " + sys_nm);
		return tables;
	}
	
	public static void main(String[] args) throws Exception {
		long s = System.currentTimeMillis();
		
		CompareHistoryCDHPRDnCDP test = new CompareHistoryCDHPRDnCDP();
		test.start();
		
		System.out.printf("%,.3f sec%n", (System.currentTimeMillis() - s) / 1000f);
	}
		
}

