package info;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;

public class UpdateCountHistoryCDHnCDP2 {

	public void start() throws Exception {
		File cdh_file = new File("script/cdp/count_cdh_result");
		File cdp_file = new File("script/cdp/count_cdp_result");

		if (cdh_file.exists()) {
			ProcessBuilder pb = new ProcessBuilder("hadoop", "fs", "-put", "-f", "script/cdp/count_cdh_result", "/user/hive/warehouse/compare_count_cdh");
			Process p = pb.start();
			p.waitFor();
			p.destroy();
		}

		if (cdp_file.exists()) {
			ProcessBuilder pb = new ProcessBuilder("hadoop", "fs", "-put", "-f", "script/cdp/count_cdp_result", "/user/hive/warehouse/compare_count_cdp");
			Process p = pb.start();
			p.waitFor();
			p.destroy();
		}

		Connection cdp_impala_conn;
		cdp_impala_conn = DriverManager.getConnection(
				"jdbc:impala://ip:port/default;AuthMech=3;UseNativeQuery=1;OptimizedInsert=0;PreparedMetaLimitZero=0;CastStringParamsForInert=0;NonSSPs=CastStringParamsForInert",
				"id", "pw");

		Statement cdp_stmt = cdp_impala_conn.createStatement();

		try {
			int updated;
			// reg date
			SimpleDateFormat sDate = new SimpleDateFormat("yyyyMMddHH");
			String reg_dt = sDate.format(new Date());

			cdp_stmt.execute("refresh compare_count_cdh");
			updated = cdp_stmt.executeUpdate(
					"upsert into default.compare_history_cdh_cdp (reg_dt, sys_id, db_nm, tbl_nm, cdh_count) " +
					"select '" + reg_dt + "', 'cdh_prd', split_part(tbl,'.',1), split_part(tbl,'.',2), cnt from compare_count_cdh");
			
			System.out.println("update complete cdh count: " + updated);

			
			cdp_stmt.execute("refresh compare_count_cdp");
			updated = cdp_stmt.executeUpdate(
					"upsert into default.compare_history_cdh_cdp (reg_dt, sys_id, db_nm, tbl_nm, cdp_count) " +
					"select '" + reg_dt + "', 'cdh_prd', split_part(tbl,'.',1), split_part(tbl,'.',2), cnt from compare_count_cdp");
			
			System.out.println("update complete cdp count: " + updated);

			
			cdp_stmt.execute(
					"update default.compare_history_cdh_cdp set compare_count = '' where cdh_count is null and cdp_count is null and reg_dt='" + reg_dt + "'");
			cdp_stmt.execute(
					"update default.compare_history_cdh_cdp set compare_count = 'X' where cdh_count <> cdp_count and reg_dt='" + reg_dt + "'");
			cdp_stmt.execute(
					"update default.compare_history_cdh_cdp set compare_count = 'O' where cdh_count = cdp_count and reg_dt='" + reg_dt + "'");

			System.out.println("update complete compare count");
		} finally {
			cdp_stmt.close();
			cdp_impala_conn.close();
		}
	}

	public static void main(String[] args) throws Exception {

		long s = System.currentTimeMillis();

		UpdateCountHistoryCDHnCDP2 test = new UpdateCountHistoryCDHnCDP2();
		test.start();

		System.out.printf("%,.3f sec%n", (System.currentTimeMillis() - s) / 1000f);
	}
}